- name: |
    Get the switch id (Fabric --> Access Policies --> Inventory --> Pod X --> Leaf X --> fabricNode.id) based on the leaf name from crf-o-matic.
    Fail if no leaf name.
  cisco.aci.aci_rest:
    host: "{{ fabric }}"
    username: "{{ vault_secrets['username'] }}"
    password: "{{ vault_secrets['password'] }}"
    method: get
    use_proxy: False
    use_ssl: True
    validate_certs: False
    path: "/api/node/class/fabricNode.json?query-target-filter=or(wcard(fabricNode.name,\"{{ switch1 }}\"),wcard(fabricNode.name,\"{{ switch2 }}\"))"
  delegate_to: localhost
  register: fabric_node_result

- name: Assert that the leaf exists in the fabric
  assert:
    that:
      - fabric_node_result['imdata'] | length >= 2
      - fabric_node_result['status'] == 200
    fail_msg: "Leaf {{ switch1 }} or {{ switch2 }} does not exists in the fabric. Stoping..."
    success_msg: "Leaf {{ switch1 }} and {{ switch2 }} exists in the fabric. Continue..."

- name: Store the leaf ID
  set_fact:
    vpc_leaf_id: "{{ vpc_leaf_id | default([]) + [
      {
        (item | json_query('fabricNode.attributes.name')): (item | json_query('fabricNode.attributes.id'))
      }  
    ] }}"
  loop: "{{ fabric_node_result.imdata }}"
  loop_control:
    label: "Extracting the id for leaf name {{ item | json_query('fabricNode.attributes.name') }}."
